package com.weaver.seconddev.cockpit.cmd;

import com.weaver.calendar.service.RemoteAgendaService;
import com.weaver.common.base.entity.result.WeaResult;
import com.weaver.ebuilder.datasource.api.entity.SqlParamEntity;
import com.weaver.ebuilder.datasource.api.enums.SqlParamType;
import com.weaver.framework.rpc.annotation.RpcReference;
import com.weaver.seconddev.cockpit.util.DatabaseUtils;
import com.weaver.seconddev.cockpit.util.JucailinCockpitUtils;
import com.weaver.teams.client.doc.remote.DocClientService;
import com.weaver.teams.domain.user.SimpleEmployee;
import com.weaver.workflow.common.constant.list.listdimension.RequestListInitDimensionTabEnum;
import com.weaver.workflow.common.entity.list.api.RequestListConditionApiEntity;
import com.weaver.workflow.common.entity.list.api.publicapi.RequestCountInfoPAEntity;
import com.weaver.workflow.common.entity.list.api.publicapi.RequestListInfoPAEntity;
import com.weaver.workflow.list.api.rest.publicapi.WflRequestListRest;
import com.weaver.workrelate.performance.api.rest.RemotePerformanceService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import java.time.LocalDateTime;
import java.time.temporal.ChronoUnit;
import java.util.*;

/**
 * 文档分析
 *
 * @author shil
 * @version 1.00版本
 * @Date 2024/5/22
 */
@Component
public class CockpitDocumentAnalysisCmd {
    //日志
    private final static Logger log = LoggerFactory.getLogger(CockpitWorkDate4TypeCmd.class);

    @RpcReference
    public RemotePerformanceService remotePerformanceService;

    @Autowired
    private JucailinCockpitUtils jucailinCockpitUtils;

    @Autowired
    private DatabaseUtils databaseUtils;

    @RpcReference(group = "workflow")
    WflRequestListRest wflRequestListRest;

    @RpcReference
    DocClientService docClientService;

    @RpcReference
    RemoteAgendaService remoteAgendaService;

    public Map<String, Object> getDataInfo(SimpleEmployee employee, Map<String, Object> paramMap,String tenantKey) {

        Map<String, Object> recordMap = new HashMap<String, Object>();
        try {
            List<Map<String,String>> dataList = getDocumentDate(employee,tenantKey);
            recordMap.put("leftdata",dataList);
            Map<String,String> chartMap = new HashMap<String,String>();
            chartMap.put("项目管理","16.6");
            chartMap.put("客户服务","16.6");
            chartMap.put("产品中心","40.8");
            chartMap.put("市场管理","10.0");
            chartMap.put("其他","8.6");
            recordMap.put("rightdata",chartMap);
        } catch (Exception e) {
            e.printStackTrace();
            log.error("CockpitDocumentAnalysisCmd-e:" + e);
        }
        return recordMap;
    }

    /***
     *
     * @param employee
     * @param tenantKey
     * @return
     */
    public List<Map<String,String>> getDocumentDate(SimpleEmployee employee,String tenantKey) {

        List<Map<String,String>> doclist = new ArrayList<>(100);
        try {
            long employeeId = employee.getEmployeeId();

            Map<String,String> docMap = new HashMap<String,String>();


            String doc_count4 = getDocumentDateAmount(employeeId,"1",tenantKey);
            String doc_name4 = "待查看文档数量";
            String doc_pkey4 = "document.create.amount";
            String doc_url4 =  jucailinCockpitUtils.getUfPropData(doc_pkey4,tenantKey);
            docMap.put("count",doc_count4);
            docMap.put("name",doc_name4);
            docMap.put("url",doc_url4);
            doclist.add(docMap);

            docMap = new HashMap<String,String>();
            String doc_count5 = getDocumentDateAmount(employeeId,"1",tenantKey);
            String doc_name5 = "我的积分";
            String doc_pkey5 = "document.create.amount";
            String doc_url5 =  jucailinCockpitUtils.getUfPropData(doc_pkey5,tenantKey);
            docMap.put("count",doc_count5);
            docMap.put("name",doc_name5);
            docMap.put("url",doc_url5);
            doclist.add(docMap);

            docMap = new HashMap<String,String>();
            String doc_count6 = getDocumentDateAmount(employeeId,"1",tenantKey);
            String doc_name6 = "我的分享";
            String doc_pkey6 = "document.create.amount";
            String doc_url6 =  jucailinCockpitUtils.getUfPropData(doc_pkey6,tenantKey);
            docMap.put("count",doc_count6);
            docMap.put("name",doc_name6);
            docMap.put("url",doc_url6);
            doclist.add(docMap);


            docMap = new HashMap<String,String>();
            String doc_count7 = getDocumentDateAmount(employeeId,"1",tenantKey);
            String doc_name7 = "下属知识";
            String doc_pkey7 = "document.create.amount";
            String doc_url7 =  jucailinCockpitUtils.getUfPropData(doc_pkey7,tenantKey);
            docMap.put("count",doc_count7);
            docMap.put("name",doc_name7);
            docMap.put("url",doc_url7);
            doclist.add(docMap);


            docMap = new HashMap<String,String>();
            String doc_count1 = getDocumentDateAmount(employeeId,"1",tenantKey);
            String doc_name1 = "我创建的文档";
            String doc_pkey1 = "document.create.amount";
            String doc_url1 =  jucailinCockpitUtils.getUfPropData(doc_pkey1,tenantKey);
            docMap.put("count",doc_count1);
            docMap.put("name",doc_name1);
            docMap.put("url",doc_url1);
            doclist.add(docMap);

            docMap = new HashMap<String,String>();
            String doc_count2 = getDocumentDateAmount(employeeId,"2",tenantKey);
            String doc_name2 = "共享给我的文档";
            String doc_pkey2 = "document.read.amount";
            String doc_url2 =  jucailinCockpitUtils.getUfPropData(doc_pkey2,tenantKey);
            docMap.put("count",doc_count2);
            docMap.put("name",doc_name2);
            docMap.put("url",doc_url2);
            doclist.add(docMap);

            docMap = new HashMap<String,String>();
            String doc_count3 = getDocumentDateAmount(employeeId,"3",tenantKey);
            String doc_name3 = "我订阅的文档";
            String doc_pkey3 = "document.number.amount";
            String doc_url3 =  jucailinCockpitUtils.getUfPropData(doc_pkey3,tenantKey);
            docMap.put("count",doc_count3);
            docMap.put("name",doc_name3);
            docMap.put("url",doc_url3);
            doclist.add(docMap);


            docMap = new HashMap<String,String>();
            String doc_count8 = getDocumentDateAmount(employeeId,"3",tenantKey);
            String doc_name8 = "我关注的文档";
            String doc_pkey8 = "document.number.amount";
            String doc_url8 =  jucailinCockpitUtils.getUfPropData(doc_pkey8,tenantKey);
            docMap.put("count",doc_count8);
            docMap.put("name",doc_name8);
            docMap.put("url",doc_url8);
            doclist.add(docMap);

        } catch (Exception e) {
            e.printStackTrace();
            log.error("DevQuestCountCmd-Exception:" + e);
        }
        return doclist;
    }


    public String getDocumentDateAmount(Long employeeId,String type,String tenantKey) {
        String count = "0";
        String groupId = "weaver-doc-service";
        String sourceType = "LOGIC";

        try {
            if("1".equals(type)){

                int doccreatecount = docClientService.countByCreator(employeeId);
                count = doccreatecount + "";

            }else if("2".equals(type)){

                String sql =" select count(1) as cou " +
                        "  from document " +
                        "  where id in( select targetid from doc_documentlogs where log_operator <> ? and operatetype = 'read' and delete_type = 0 and tenant_key=? and doc_status = 2 ) \n" +
                        "  and creator = ?\n" +
                        "  and delete_type = 0\n" +
                        "  and tenant_key= ? " ;

                List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
                SqlParamEntity sqlParamEntity = new SqlParamEntity();
                sqlParamEntity.setParamType(SqlParamType.LONG);
                sqlParamEntity.setValue(employeeId+"");
                sqlparam.add(sqlParamEntity);

                sqlParamEntity = new SqlParamEntity();
                sqlParamEntity.setParamType(SqlParamType.VARCHAR);
                sqlParamEntity.setValue(tenantKey);
                sqlparam.add(sqlParamEntity);

                sqlParamEntity = new SqlParamEntity();
                sqlParamEntity.setParamType(SqlParamType.LONG);
                sqlParamEntity.setValue(employeeId+"");
                sqlparam.add(sqlParamEntity);

                sqlParamEntity = new SqlParamEntity();
                sqlParamEntity.setParamType(SqlParamType.VARCHAR);
                sqlParamEntity.setValue(tenantKey);
                sqlparam.add(sqlParamEntity);

                Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
                List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
                if(recordList.size()>0){
                    count = String.valueOf(recordList.get(0).get("cou"));
                }
            }else if("3".equals(type)){
                String sql =" select count(1) as cou \n" +
                        " from doc_documentlogs  \n" +
                        " where targetid in( select id from document where creator = ? and delete_type = 0 and tenant_key=? and doc_status = 2) \n" +
                        " and log_operator <> ? \n" +
                        " and OPERATETYPE = 'read' \n" +
                        " and delete_type = 0 \n" +
                        " and tenant_key=? " ;

                List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
                SqlParamEntity sqlParamEntity = new SqlParamEntity();
                sqlParamEntity.setParamType(SqlParamType.LONG);
                sqlParamEntity.setValue(employeeId+"");
                sqlparam.add(sqlParamEntity);

                sqlParamEntity = new SqlParamEntity();
                sqlParamEntity.setParamType(SqlParamType.VARCHAR);
                sqlParamEntity.setValue(tenantKey);
                sqlparam.add(sqlParamEntity);

                sqlParamEntity = new SqlParamEntity();
                sqlParamEntity.setParamType(SqlParamType.LONG);
                sqlParamEntity.setValue(employeeId+"");
                sqlparam.add(sqlParamEntity);

                sqlParamEntity = new SqlParamEntity();
                sqlParamEntity.setParamType(SqlParamType.VARCHAR);
                sqlParamEntity.setValue(tenantKey);
                sqlparam.add(sqlParamEntity);

                Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
                List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
                if(recordList.size()>0){
                    count = String.valueOf(recordList.get(0).get("cou"));
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
            log.error("getDocCreateNum:" + e);
        }

        return count;
    }

}
